Name:		rekall
Summary:	A KDE database front-end application
Version:	2.4.0
Release:	4%{?dist}
Group:		Development/Tools
License:	GPL
URL:		http://www.rekallrevealed.org/
Source0: 	http://www.rekallrevealed.org/packages/%{name}-%{version}.tar.gz
Patch1:		rekall-2.4.0-64bitfix.patch
Patch2:		rekall-2.4.0-gcc4.patch
Patch3:		rekall-2.4.0-qtfix.patch
Patch4:		rekall-2.4.0-noldconfig.patch
Patch5:		rekall-2.4.0-lib64.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	python-devel, mysql-devel, postgresql-devel
BuildRequires:	kdelibs-devel, desktop-file-utils, libacl-devel
BuildRequires:  scons, flex, bison
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
Requires:	rekall-common = %{version}-%{release}
Provides:	rekall-devel = %{version}-%{release}
Obsoletes:	rekall-devel

%description
Rekall is a database front-end, however, Rekall is not itself a 
database, and does not include a database. By this we mean that data 
is stored somewhere else in an SQL server, and Rekall is fundementally 
just a tool to extract, display and update that data (of course, it does 
lots more than that, it does forms and reports and scripting...). It is 
database agnostic, and does not have any preferred database (plugins are 
available for MySQL and PostgreSQL).

%package common
Summary: Rekall common libraries
Group: System Environment/Libraries

%description common
This package contains a set of common libraries that both rekall and 
rekall-runtime require to function.

%package docs
Summary: Rekall documentation
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description docs
Documentation for Rekall

%package extra
Summary: Rekall Extra Stuff Plugin
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description extra
Rekall Extra Stuff Plugin.

%package mysql
Summary: Rekall MySQL driver
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description mysql
Driver to add MySQL support to Rekall.

%package postgresql
Summary: Rekall PostgreSQL driver
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description postgresql
Driver to add PostgreSQL support to Rekall.

%package python
Summary: Rekall Python support
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description python
Python components and scripts for Rekall.

%package runtime
Summary: Rekall runtime environment
Group: Development/Tools
Provides: %{name}-runtime-devel = %{version}-%{release}
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
Requires: rekall-common = %{version}-%{release}

%description runtime
RekallRT is the runtime version of Rekall. It contains all the functionality 
of Rekall except that all design functions are removed, and direct access to 
tables and queries is restricted.

Typically, you can develop a Rekall application with the full version, then 
allow users to run it under the runtime version. Such a user is restricted 
to accessing the database only via the forms and reports that you have 
designed, and via any associated scripts.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%ifarch sparc64 alpha x86_64 ia64
%patch5 -p1
%endif
rm -rf libs/el32/hash.cpp.orig libs/kbase/kb_parse.cpp.orig libs/kbase/kb_link.cpp.orig

%build
export KDEDIR=%{_prefix}
PARSED_OPT_FLAGS=`echo \'$RPM_OPT_FLAGS\' | sed "s/ /',/g" | sed "s/',/', '/g"`
sed -i "s|'-Wall'|[$PARSED_OPT_FLAGS]|" scons/rkBuilder.py
echo "prefix=%{_prefix}" >> scons/settings.qt3
echo "with-mysql-libraries=%{_libdir}/mysql" >> scons/settings.qt3
echo "with-pgsql-libraries=%{_libdir}" >> scons/settings.qt3
echo "with-python-libraries=%{_libdir}" >> scons/settings.qt3
echo "with-qt-includes=%{_libdir}/qt-3.3/include" >> scons/settings.qt3
echo "with-qt-libraries=%{_libdir}/qt-3.3/lib" >> scons/settings.qt3
cp scons/settings.qt3 settings
cp scons/Makefile .

make config
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mv $RPM_BUILD_ROOT%{_datadir}/doc/HTML $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
install -m0644 kbase/rekall.desktop $RPM_BUILD_ROOT%{_datadir}
install -m0644 kbase/rekallrt.desktop $RPM_BUILD_ROOT%{_datadir}

desktop-file-install --vendor fedora --delete-original \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category X-Fedora \
  --add-category Application \
  --add-category Office \
  --add-mime-type Application/x-rlk \
  $RPM_BUILD_ROOT%{_datadir}/%{name}.desktop

sed -i -e 's|Rekall|Rekall RT|' $RPM_BUILD_ROOT%{_datadir}/%{name}rt.desktop
sed -i -e 's|rekall.png|rekallrt.png|' $RPM_BUILD_ROOT%{_datadir}/%{name}rt.desktop

desktop-file-install --vendor fedora --delete-original \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category X-Fedora \
  --add-category Application \
  --add-category Office \
  --add-mime-type Application/x-rlk \
  $RPM_BUILD_ROOT%{_datadir}/%{name}rt.desktop

# No need to have this file twice.
rm -rf $RPM_BUILD_ROOT%{_datadir}/apps/rekallqt/LICENSE

cd $RPM_BUILD_ROOT%{_datadir}
ln -s %{_datadir}/apps/rekallqt/icons/hicolor/32x32/apps/rekall.png pixmaps/rekall.png
cp apps/rekallqt/icons/hicolor/32x32/apps/rekall.png pixmaps/rekallrt.png
cd $RPM_BUILD_ROOT%{_bindir}
ln -s %{_bindir}/rekallqt rekall
ln -s %{_bindir}/rekallqtManual rekallManual
ln -s %{_bindir}/rekallqtrt rekallrt

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
update-desktop-database %{_datadir}/applications &> /dev/null

%postun
/sbin/ldconfig
if [ "$1" = "0" ]; then
  update-desktop-database %{_datadir}/applications &> /dev/null
fi

%post common -p /sbin/ldconfig

%postun common -p /sbin/ldconfig

%post extra -p /sbin/ldconfig

%postun extra -p /sbin/ldconfig

%post mysql -p /sbin/ldconfig

%postun mysql -p /sbin/ldconfig

%post postgresql -p /sbin/ldconfig

%postun postgresql -p /sbin/ldconfig

%post python -p /sbin/ldconfig

%postun python -p /sbin/ldconfig

%post runtime
/sbin/ldconfig
update-desktop-database %{_datadir}/applications &> /dev/null

%postun runtime
/sbin/ldconfig
if [ "$1" = "0" ]; then
  update-desktop-database %{_datadir}/applications &> /dev/null
fi

%files
%defattr(-, root, root, 0755)
%doc LICENSE
%{_libdir}/librekallqt.so
%{_bindir}/rekall
%{_bindir}/rekallqt
%{_datadir}/pixmaps/rekall.png
%dir %{_datadir}/apps/rekallqt
%{_datadir}/apps/rekallqt/dict/
%{_datadir}/apps/rekallqt/gui/
%{_datadir}/apps/rekallqt/help/
%{_datadir}/apps/rekallqt/highlights/
%{_datadir}/apps/rekallqt/icons/
%{_datadir}/apps/rekallqt/keymap*
%{_datadir}/apps/rekallqt/pics/
%{_datadir}/apps/rekallqt/rekall.png
%{_datadir}/apps/rekallqt/rekall_lite.png
%{_datadir}/apps/rekallqt/services/rekall_component.desktop
%{_datadir}/apps/rekallqt/services/rekall_copier.desktop
%{_datadir}/apps/rekallqt/services/rekall_driver_xbase.desktop
%{_datadir}/apps/rekallqt/services/rekall_dummy.desktop
%{_datadir}/apps/rekallqt/services/rekall_editor.desktop
%{_datadir}/apps/rekallqt/services/rekall_form.desktop
%{_datadir}/apps/rekallqt/services/rekall_macro.desktop
%{_datadir}/apps/rekallqt/services/rekall_query.desktop
%{_datadir}/apps/rekallqt/services/rekall_report.desktop
%{_datadir}/apps/rekallqt/services/rekall_script_kjs.desktop
%{_datadir}/apps/rekallqt/services/rekall_script_kjs_client.desktop
%{_datadir}/apps/rekallqt/services/rekall_table.desktop
%{_datadir}/apps/rekallqt/script/
%{_datadir}/apps/rekallqt/stock/
%{_datadir}/apps/rekallqt/test/
%{_datadir}/apps/rekallqt/wizards/
%{_datadir}/applications/fedora-rekall.desktop
%{_libdir}/librekallqt_app.so
%{_libdir}/librekallqt_componentview.so
%{_libdir}/librekallqt_copierview.so
%{_libdir}/librekallqt_driver_xbase.so
%{_libdir}/librekallqt_editor.so
%{_libdir}/librekallqt_el32.so
%{_libdir}/librekallqt_formview.so
%{_libdir}/librekallqt_macroview.so
%{_libdir}/librekallqt_queryview.so
%{_libdir}/librekallqt_reportview.so
%{_libdir}/librekallqt_tableview.so
%{_libdir}/librekallqt_support_xbase.so
%{_libdir}/librekallqt_support_xbsql.so
%{_libdir}/librekallqt_wizard.so

%files common
%defattr(-, root, root, 0755)
%{_libdir}/librekallqt_common.so
%{_libdir}/librekallqt_kde.so
%{_libdir}/librekallqt_kjs.so
%{_libdir}/librekallqt_script_kjs.so

%files docs
%defattr(-, root, root, 0755)
%doc AUTHORS README.FIRST Release.Notes
%{_bindir}/rekallManual
%{_bindir}/rekallqtManual
%{_docdir}/%{name}-%{version}/*
%{_datadir}/apps/rekallqt/manual/

%files extra
%defattr(-, root, root, 0755)
%{_datadir}/apps/rekallqt/services/rekall_plugin_extra.desktop
%{_libdir}/librekallqt_plugin_extra.so

%files mysql
%defattr(-, root, root, 0755)
%{_datadir}/apps/rekallqt/services/rekall_driver_mysql.desktop
%{_libdir}/librekallqt_driver_mysql.so

%files postgresql
%defattr(-, root, root, 0755)
%{_datadir}/apps/rekallqt/services/rekall_driver_pgsql.desktop
%{_libdir}/librekallqt_driver_pgsql.so

%files python
%defattr(-, root, root, 0755)
%dir %{_datadir}/apps/rekallqt/stock/component/py
%{_datadir}/apps/rekallqt/stock/component/py/*
%dir %{_datadir}/apps/rekallqt/script/py
%{_datadir}/apps/rekallqt/script/py/*
%{_datadir}/apps/rekallqt/services/rekall_script_py.desktop
%{_libdir}/librekallqt_script_py.so

%files runtime
%defattr(-, root, root, 0755)
%{_bindir}/rekallrt
%{_bindir}/rekallqtrt
%{_datadir}/apps/rekallqt/services/rekallrt_form.desktop
%{_datadir}/apps/rekallqt/services/rekallrt_query.desktop
%{_datadir}/apps/rekallqt/services/rekallrt_report.desktop
%{_datadir}/apps/rekallqt/services/rekallrt_table.desktop
%{_datadir}/apps/rekallqt/services/rekallrt_plugin_extra.desktop
%{_datadir}/apps/rekallqt/services/rekallrt_script_py.desktop
%{_datadir}/apps/rekallqtrt
%{_datadir}/applications/fedora-rekallrt.desktop
%{_datadir}/pixmaps/rekallrt.png
%{_libdir}/librekallqtrt_plugin_extra.so
%{_libdir}/librekallqtrt_script_py.so
%{_libdir}/librekallqtrt.so*
%{_libdir}/librekallqtrt_app.so*
%{_libdir}/librekallqtrt_formview.so
%{_libdir}/librekallqtrt_queryview.so
%{_libdir}/librekallqtrt_reportview.so
%{_libdir}/librekallqtrt_tableview.so

%changelog
* Thu Mar  2 2006 Tom "spot" Callaway <tcallawa@redhat.com> 2.4.0-4
- really fix 64bit arches

* Wed Mar  1 2006 Tom "spot" Callaway <tcallawa@redhat.com> 2.4.0-3
- fix x86_64

* Tue Feb 28 2006 Tom "spot" Callaway <tcallawa@redhat.com> 2.4.0-2
- bump for FC-5

* Tue Jan 10 2006 Tom "spot" Callaway <tcallawa@redhat.com> 2.4.0-1
- bump to 2.4.0

* Thu Oct  5 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.4-8
- FC-3 is held together with duct-tape

* Wed Oct  5 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.4-7
- BR: libacl-devel

* Fri Sep 23 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.4-5
- 64 bit fixes (the shock!)

* Thu Sep 22 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.4-4
- yes. another one.

* Thu Sep 22 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.4-3
- yet another 64 bit long issue

* Thu Sep 22 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.4-2
- another 64 bit long issue

* Thu Sep 22 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.4-1
- go to 2.2.4
- fix 64 bit long issue

* Mon Sep 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.3-5
- get rid of unnecessary BR: xbase-devel and qt-devel

* Sat Sep 17 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.3-4
- fix runtime package to actually be standalone
- create common package that both rekall and rekall-runtime need

* Thu Sep  8 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.3-3
- runtime: R: desktop-file-utils
- use %%{_datadir} everywhere

* Sun Sep  4 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.3-2
- BR: desktop-file-utils
- R: desktop-file-utils
- fix typo in runtime desc
- set vendor to fedora not kde
- add Office, Application to category
- add rlk mimetype
- make symlink for icon
- provide runtime-devel in runtime package
- include .la files
- lots of missing post/postun added
- icon for the runtime bits

* Fri Jun 17 2005 Tom "spot" Callaway <tcallawa@redhat.com> 2.2.3-1
- initial package for Fedora Extras
